// $Id$

/*************************************************************************
 * XDAQ Components for Distributed Data Acquisition                      *
 * Copyright (C) 2000-2009, CERN.			                 *
 * All rights reserved.                                                  *
 * Authors: J. Gutleber and L. Orsini					 *
 *                                                                       *
 * For the licensing terms see LICENSE.		                         *
 * For the list of contributors see CREDITS.   			         *
 *************************************************************************/

#ifndef _xdata_soap_FloatSerializer_h_
#define _xdata_soap_FloatSerializer_h_

#include <xercesc/dom/DOM.hpp>
#include "xdata/Serializable.h"
#include "xdata/exception/Exception.h"
#include "xdata/soap/ObjectSerializer.h"
#include "xdata/soap/Serializer.h"
#include "xdata/XStr.h"
#include "xdata/Float.h"

XERCES_CPP_NAMESPACE_USE

namespace xdata {
namespace soap {

class FloatSerializer : public xdata::soap::ObjectSerializer  
{	
	public:
	virtual ~FloatSerializer();

	std::string type() const;
	DOMElement *  exportAll(xdata::Serializer * serializer,  xdata::Serializable * serializable, DOMElement * targetNode);
	void exportQualified (xdata::Serializer * serializer,  xdata::Serializable * serializable,
	DOMNode* queryNode, DOMElement* resultNode) ;
	void import (xdata::Serializer * serializer,  xdata::Serializable * serializable, DOMNode* targetNode) ;	
};

}}

#endif
