
/*************************************************************************
 * XDAQ Components for Distributed Data Acquisition                      *
 * Copyright (C) 2000-2004, CERN.                                        *
 * All rights reserved.                                                  *
 * Authors: J. Gutleber, G. Lo Presti and L. Orsini                      *
 *                                                                       *
 * For the licensing terms see LICENSE.                                  *
 * For the list of contributors see CREDITS.                             *
 *************************************************************************/

#include "xdaqV.h"
#include "jxta/ptjxtaV.h"
#include "jxta/PeerTransportJxta.h"

#include <string>
#include <set>


XDAQ_INSTANTIATE (PeerTransportJxta)

GETPACKAGEINFO (ptjxta)

void ptjxta::checkPackageDependencies() 
{
    CHECKDEPENDENCY (xdaq)
}

std::set<std::string, std::less<std::string> > ptjxta::getPackageDependencies()
{
    std::set<std::string, std::less<std::string> > dependencies;
    ADDDEPENDENCY (dependencies, xdaq);
    return dependencies;
}
