// $Id$

/*************************************************************************
 * XDAQ Components for Distributed Data Acquisition                      *
 * Copyright (C) 2000-2009, CERN.			                 *
 * All rights reserved.                                                  *
 * Authors: J. Gutleber and L. Orsini					 *
 *                                                                       *
 * For the licensing terms see LICENSE.		                         *
 * For the list of contributors see CREDITS.   			         *
 *************************************************************************/

#include "xdata/exdr/FixedSizeOutputStreamBuffer.h"

xdata::exdr::FixedSizeOutputStreamBuffer::FixedSizeOutputStreamBuffer(char* buf, unsigned int size): OutputStreamBuffer(buf, size)
{
} 

xdata::exdr::FixedSizeOutputStreamBuffer::~FixedSizeOutputStreamBuffer()
{
} 

void xdata::exdr::FixedSizeOutputStreamBuffer::overflow() 
{
	// Fixed size does not allow to overflow the buffer
	XCEPT_RAISE(xdata::exception::Exception, "Fixed size buffer overflows");
}
