// $Id$

/*************************************************************************
 * XDAQ Components for Distributed Data Acquisition                      *
 * Copyright (C) 2000-2009, CERN.			                 *
 * All rights reserved.                                                  *
 * Authors: J. Gutleber and L. Orsini					 *
 *                                                                       *
 * For the licensing terms see LICENSE.		                         *
 * For the list of contributors see CREDITS.   			         *
 *************************************************************************/

#include "config/version.h"
#include "xcept/version.h"
#include "toolbox/version.h"
#include "xdata/version.h"

GETPACKAGEINFO(xdata)

void xdata::checkPackageDependencies() 
{
	CHECKDEPENDENCY(config);   
	CHECKDEPENDENCY(xcept);   
	CHECKDEPENDENCY(toolbox);   
}

std::set<std::string, std::less<std::string> > xdata::getPackageDependencies()
{
	std::set<std::string, std::less<std::string> > dependencies;

	ADDDEPENDENCY(dependencies,config); 
	ADDDEPENDENCY(dependencies,xcept); 
	ADDDEPENDENCY(dependencies,toolbox); 
  
	return dependencies;
}	
	
